/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */

package com.sun.jini.discovery.kerberos;

import com.sun.jini.discovery.internal.EndpointInternals;
import com.sun.jini.discovery.internal.EndpointInternalsPermission;
import net.jini.jeri.kerberos.KerberosEndpoint;

/**
 * Provides a rendezvous point for the net.jini.jeri.kerberos transport
 * provider to register an EndpointInternals instance used by provider classes
 * for the net.jini.discovery.kerberos unicast discovery format.
 */
public class EndpointInternalsAccess {

    private static EndpointInternals endpointInternals = null;
    private static final Object lock = new Object();

    static {
	try {
	    KerberosEndpoint.getInstance("triggerStaticInitializer", 1, null);
	} catch (NullPointerException e) {
	    // expected
	}
    }

    private EndpointInternalsAccess() {
    }

    /**
     * Registers EndpointInternals instance to use for back-door operations on
     * KerberosEndpoint and KerberosServerEndpoints.  This method should be
     * called only once, from within the static initializer of the
     * KerberosEndpoint class.  If a security manager is installed, this method
     * checks that the calling context has EndpointInternalsPermission.  Throws
     * IllegalStateException if EndpointInternals instance has already been
     * set.
     */
    public static void set(EndpointInternals endpointInternals) {
	if (endpointInternals == null) {
	    throw new NullPointerException();
	}
	SecurityManager sm = System.getSecurityManager();
	if (sm != null) {
	    sm.checkPermission(new EndpointInternalsPermission());
	}
	synchronized (lock) {
	    if (EndpointInternalsAccess.endpointInternals != null) {
		throw new IllegalStateException(
		    "endpointInternals already set");
	    }
	    EndpointInternalsAccess.endpointInternals = endpointInternals;
	}
    }

    /**
     * Returns registered EndpointInternals instance.  Throws
     * IllegalStateException if EndpointInternals instance has not been set.
     */
    static EndpointInternals get() {
	synchronized (lock) {
	    if (endpointInternals == null) {
		throw new IllegalStateException("endpointInternals not set");
	    }
	    return endpointInternals;
	}
    }
}
